<?php

namespace DataView;

class MitgliedDynamicMonthyear_dynamic_parent {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderTabTableAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((false))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="var self = this; $.get(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'open', fop_table: 'mitgliedDynamicMonthyear', fop_id: '_', fop_from: location.href}, true)).then(function () { open_url(self.href, false);}); return false;" href="<?php echo htmlentities(\TablesRouter\MitgliedDynamicMonthyear::createURL2(['from' => \FOP\Util::getBackUrl(), 'column_dynamic:parent' => $id])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), sprintf(_('versions of %s'), _('Mitglied')))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_mitgliedDynamicMonthyear_dynamic:parent']) ? intval($_GET['page_mitgliedDynamicMonthyear_dynamic:parent']) : 0);
								$addlines = (isset($_GET['addlines_mitgliedDynamicMonthyear_dynamic:parent']) ? intval($_GET['addlines_mitgliedDynamicMonthyear_dynamic:parent']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET, $id);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'dynamic:time',
												'desc' => _('validfrom'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['dynamic:time'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'tarif',
												'desc' => _('Mitgliedsbeitrag'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['tarif'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('mitgliedDynamicMonthyear_dynamic:parent'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='dynamic:time'
												data-order='<?php echo intval($columns['dynamic:time']['order']); ?>'
												data-width='<?php echo intval($columns['dynamic:time']['width']); ?>'
												data-collapsed='<?php echo intval($columns['dynamic:time']['collapsed']); ?>'
												style='width: <?php echo intval($columns['dynamic:time']['width']); ?>px; <?php if ($columns['dynamic:time']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadmitgliedDynamicMonthyear_dynamic_parent(); 
		}});
		
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'dynamic:time ASC') {
			query['sort_mitgliedDynamicMonthyear_dynamic:parent'] = 'dynamic:time DESC';
		 } else if (query['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'dynamic:time DESC') {
		 	delete query['sort_mitgliedDynamicMonthyear_dynamic:parent'];
		 } else {
			query['sort_mitgliedDynamicMonthyear_dynamic:parent'] = 'dynamic:time ASC';
		 }
		 reloadmitgliedDynamicMonthyear_dynamic_parent();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('validfrom')); ?>'><?php echo(_('validfrom')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_mitgliedDynamicMonthyear_dynamic:parent']) && $_GET['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'dynamic:time ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_mitgliedDynamicMonthyear_dynamic:parent']) && $_GET['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'dynamic:time DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['range_max_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['deps_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['fullsearch_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['dynamic_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['search_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['searchnot_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) || isset($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['dynamic:time']['header'] = ob_get_contents(); ob_end_clean();
											$columns['dynamic:time']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['dynamic:time']['width']); ?>px; <?php if ($columns['dynamic:time']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='dynamic:time'><span class='overflow-text' title="<?php echo htmlentities(($item['dynamic:time']) ? date(_('monthyearformat_php'), mktime(1, 1, 1, intval($item['dynamic:time']) % 12 + 1, 1, floor(intval($item['dynamic:time'])/12))) : ''); ?>"><?php echo htmlentities(($item['dynamic:time']) ? date(_('monthyearformat_php'), mktime(1, 1, 1, intval($item['dynamic:time']) % 12 + 1, 1, floor(intval($item['dynamic:time'])/12))) : ''); ?></span></div><?php
											};
											$columns['dynamic:time']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='dynamic:time'
													data-order='<?php echo intval($columns['dynamic:time']['order']); ?>'
													data-width='<?php echo intval($columns['dynamic:time']['width']); ?>'
													data-collapsed='<?php echo intval($columns['dynamic:time']['collapsed']); ?>'
													style='width: <?php echo intval($columns['dynamic:time']['width']); ?>px; <?php if ($columns['dynamic:time']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='tarif'
												data-order='<?php echo intval($columns['tarif']['order']); ?>'
												data-width='<?php echo intval($columns['tarif']['width']); ?>'
												data-collapsed='<?php echo intval($columns['tarif']['collapsed']); ?>'
												style='width: <?php echo intval($columns['tarif']['width']); ?>px; <?php if ($columns['tarif']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadmitgliedDynamicMonthyear_dynamic_parent(); 
		}});
		
		win.append(getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter()); win.find('input').first().focus();
		return false;
	">
													<span class='title-title' title='<?php echo(_('Mitgliedsbeitrag')); ?>'><?php echo(_('Mitgliedsbeitrag')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_mitgliedDynamicMonthyear_dynamic:parent']) && $_GET['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'tarif ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_mitgliedDynamicMonthyear_dynamic:parent']) && $_GET['sort_mitgliedDynamicMonthyear_dynamic:parent'] == 'tarif DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['range_max_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['deps_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['fullsearch_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['dynamic_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['search_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['searchnot_mitgliedDynamicMonthyear_dynamic:parent_tarif']) || isset($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['tarif']['header'] = ob_get_contents(); ob_end_clean();
											$columns['tarif']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['tarif']['width']); ?>px; <?php if ($columns['tarif']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; <?php if (($item['tarif::vis'] ?? '0') == '0') { echo 'visibility: hidden;'; } ?>' data-column='tarif'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['tarif'];
	$val = $item['tarif::description'];
	$canView = $item['tarif::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"tarif\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, false);\" href=\"" . \TablesRouter\Tarif::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('beitragsfrei') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['tarif']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='tarif'
													data-order='<?php echo intval($columns['tarif']['order']); ?>'
													data-width='<?php echo intval($columns['tarif']['width']); ?>'
													data-collapsed='<?php echo intval($columns['tarif']['collapsed']); ?>'
													style='width: <?php echo intval($columns['tarif']['width']); ?>px; <?php if ($columns['tarif']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-table-header .fop-table-column .title,
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-column-handle,
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-table-row,
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-table-row .fop-table-column,
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-table-column-multicontrol,
										#mitgliedDynamicMonthyear_dynamic_parent-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="mitgliedDynamicMonthyear_dynamic:parent">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="mitgliedDynamicMonthyear_dynamic_parent__all-checkbox">
														<input class="mdl-checkbox__input" id="mitgliedDynamicMonthyear_dynamic_parent__all-checkbox" type="checkbox" onchange="checkmitgliedDynamicMonthyear_dynamic_parent('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon mitgliedDynamicMonthyear_dynamic_parent__mass-action" style='visibility: hidden;' onclick="$.get('DataView/MitgliedDynamicMonthyear_dynamic_parent/permissions?id=' + checkmitgliedDynamicMonthyear_dynamic_parent(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('range_max_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('deps_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('fullsearch_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('dynamic_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('search_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('searchnot_mitgliedDynamicMonthyear_dynamic:parent_') == 0 || key.indexOf('filter_mitgliedDynamicMonthyear_dynamic:parent_') == 0) delete query[key]; reloadmitgliedDynamicMonthyear_dynamic_parent(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_mitgliedDynamicMonthyear_dynamic:parent_ID'] = checkmitgliedDynamicMonthyear_dynamic_parent(null, 'ID'); delete query['page_mitgliedDynamicMonthyear_dynamic:parent']; reloadmitgliedDynamicMonthyear_dynamic_parent(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkmitgliedDynamicMonthyear_dynamic_parent(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkmitgliedDynamicMonthyear_dynamic_parent(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/MitgliedDynamicMonthyear/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkmitgliedDynamicMonthyear_dynamic_parent(null, 'ID'))).then(function () { reloadmitgliedDynamicMonthyear_dynamic_parent(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('mitgliedDynamicMonthyear_dynamic_parent', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'mitgliedDynamicMonthyear_dynamic:parent', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_mitgliedDynamicMonthyear_dynamic_parent" <?php \EasyEditor\Navigation::printScroll('dv.MitgliedDynamicMonthyear_dynamic_parent', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_mitgliedDynamicMonthyear_dynamic:parent\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_mitgliedDynamicMonthyear_dynamic:parent\'] = wantedPage;
														reloadmitgliedDynamicMonthyear_dynamic_parent(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-mitgliedDynamicMonthyear-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadmitgliedDynamicMonthyear_dynamic_parent({action: \'open\', fop_table: \'mitgliedDynamicMonthyear\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox mitgliedDynamicMonthyear_dynamic_parent__checkbox mitgliedDynamicMonthyear_dynamic_parent__checkbox mitgliedDynamicMonthyear_dynamic_parent__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="mitgliedDynamicMonthyear_dynamic_parent__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="mitgliedDynamicMonthyear_dynamic_parent__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkmitgliedDynamicMonthyear_dynamic_parent(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon mitgliedDynamicMonthyear_dynamic_parent__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-mitgliedDynamicMonthyear_dynamic:parent-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\MitgliedDynamicMonthyear::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'open', fop_table: 'mitgliedDynamicMonthyear', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\MitgliedDynamicMonthyear::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/MitgliedDynamicMonthyear/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadmitgliedDynamicMonthyear_dynamic_parent(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="mitgliedDynamicMonthyear" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\MitgliedDynamicMonthyear::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadmitgliedDynamicMonthyear_dynamic_parent();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="mitgliedDynamicMonthyear" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\MitgliedDynamicMonthyear::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'open', fop_table: 'mitgliedDynamicMonthyear', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadmitgliedDynamicMonthyear_dynamic_parent();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function renderScript($id) { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', val, cb.checked);
		  } else {
			  delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
		  }reloadmitgliedDynamicMonthyear_dynamic_parent();
        
    }

		var i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout = null;
		function changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifSearchFilter(val, callback) {
			if(i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout) clearTimeout(i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout);

			i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout = setTimeout(function() {
				$.getJSON(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = val;
				});
			}, 300);
		}

	function getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig']) ? json_encode($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72" type="text">' +
			'<label class="mdl-textfield__label" for="59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = '';
					delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadmitgliedDynamicMonthyear_dynamic_parent();
					
				} else {
					$('#table_mitgliedDynamicMonthyear_dynamic_parent').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\MitgliedDynamicMonthyear_dynamic_parent::getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = '';
				delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
				reload('', items);reloadmitgliedDynamicMonthyear_dynamic_parent();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', val, cb.checked);
		  } else {
			  delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
		  }reloadmitgliedDynamicMonthyear_dynamic_parent();
        
    }

		var i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout = null;
		function changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifSearchFilter(val, callback) {
			if(i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout) clearTimeout(i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout);

			i59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72timeout = setTimeout(function() {
				$.getJSON(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = val;
				});
			}, 300);
		}

	function getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig']) ? json_encode($_GET['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72" type="text">' +
			'<label class="mdl-textfield__label" for="59a9f91c4d4c29a2f33f233edbc4223494501f266e24f3ca823ec2ba72017f72">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = '';
					delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadmitgliedDynamicMonthyear_dynamic_parent();
					
				} else {
					$('#table_mitgliedDynamicMonthyear_dynamic_parent').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\MitgliedDynamicMonthyear_dynamic_parent::getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif_orig'] = '';
				delete query['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'];
				reload('', items);reloadmitgliedDynamicMonthyear_dynamic_parent();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_mitgliedDynamicMonthyear_dynamic:parent_tarif', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_mitgliedDynamicMonthyear_dynamic_parent_tarifListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumbermitgliedDynamicMonthyear_dynamic_parent(col) {
										//var checklist = window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'] && window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col].ranges.length > 0) {
											$('.mitgliedDynamicMonthyear_dynamic_parent__mass-action').css('visibility', 'visible');
											$('.mitgliedDynamicMonthyear_dynamic_parent__action').css('visibility', 'hidden');
										} else {
											$('.mitgliedDynamicMonthyear_dynamic_parent__mass-action').css('visibility', 'hidden');
											$('.mitgliedDynamicMonthyear_dynamic_parent__action').css('visibility', 'visible');
										}
										$('.mitgliedDynamicMonthyear_dynamic_parent__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('mitgliedDynamicMonthyear_dynamic_parent__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('mitgliedDynamicMonthyear_dynamic_parent__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadmitgliedDynamicMonthyear_dynamic_parent (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										nq["id"] = <?php echo json_encode($id); ?>; 
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/MitgliedDynamicMonthyear_dynamic_parent/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/MitgliedDynamicMonthyear_dynamic_parent/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#mitgliedDynamicMonthyear_dynamic_parent-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#mitgliedDynamicMonthyear_dynamic_parent-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#mitgliedDynamicMonthyear_dynamic_parent-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumbermitgliedDynamicMonthyear_dynamic_parent('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#mitgliedDynamicMonthyear_dynamic_parent-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadmitgliedDynamicMonthyear_dynamic_parent()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkmitgliedDynamicMonthyear_dynamic_parent (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent']) window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'] = {};
										if (!window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col]) window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadmitgliedDynamicMonthyear_dynamic_parent({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col] = new IDList(ids);
													updateNumbermitgliedDynamicMonthyear_dynamic_parent(col);
												});
											} else {
												window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col] = new IDList();
												updateNumbermitgliedDynamicMonthyear_dynamic_parent(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#mitgliedDynamicMonthyear_dynamic_parent__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col].push(id);
												} else {
													window.DataViewChecked['mitgliedDynamicMonthyear_dynamic:parent'][col].remove(id);
												}
											}
											updateNumbermitgliedDynamicMonthyear_dynamic_parent(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadmitgliedDynamicMonthyear_dynamic_parent();
			
		}

	</script>
	<?php
	
    
  }

  public static function getSQL($params, $id) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* dynamic:parent */ '.qi('dynamic:parent').' AS '.qi('dynamic:parent').',
									/* dynamic:time */ '.qi('dynamic:time').' AS '.qi('dynamic:time').',
									/* operation::create */ (FALSE) AS '.qi('operation::create').',
									/* operation::delete */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::delete').',
									/* operation::edit */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ '.(\FOP\User::getIsGuest() ? 'false' : 'true').' AS '.qi('operation::view').',
									/* tarif */ '.qi('tarif').' AS '.qi('tarif').',
									/* tarif::canView */ '.qi('ref:tarif').'.'.qi('tarif:canView').' AS '.qi('tarif::canView').',
									/* tarif::description */ '.qi('ref:tarif').'.'.qi('tarif:description').' AS '.qi('tarif::description').',
									/* tarif::vis */ '.qi('mitgliedDynamicMonthyear').'.'.qi('tarifChanged').' AS '.qi('tarif::vis').',
									/* tarifChanged */ '.qi('tarifChanged').' AS '.qi('tarifChanged').',
									1
								FROM '.qi('mitgliedDynamicMonthyear').' '.qi('mitgliedDynamicMonthyear').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('tarif:ID').', '.qi('tarif').'.'.qi('name').' AS '.qi('tarif:description').', (('.\FOP\Database::quote(\FOP\User::getBuchhaltung()).')) AS '.qi('tarif:canView').' FROM '.qi('tarif').') '.qi('ref:tarif').' ON '.qi('ref:tarif').'.'.qi('tarif:ID').' = '.qi('tarif').'
								WHERE ('.qi('dynamic:parent').' = ' . \FOP\Database::quote($id) . ')
									AND ('.(\FOP\User::getIsGuest() ? 'false' : 'true').')) AS t
								WHERE ' . (isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif']) ? ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'] !== '' ? ('(' . (new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif']))->toSQL('t.'.qi('tarif').'') . ') AND ') : '') : '') . 
								(isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged']) ? ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged'] !== '' ? ('(' . (new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged']))->toSQL('t.'.qi('tarifChanged').'') . ') AND ') : '') : '') . 
								(isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']) ? ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time'] !== '' ? ('(' . (new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']))->toSQL('t.'.qi('dynamic:time').'') . ') AND ') : '') : '') . 
								(isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_ID']) ? ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getidsAction($col, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET, $id));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ('.(\FOP\User::getIsGuest() ? 'false' : 'true').') WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('mitgliedDynamicMonthyear').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getfilter_mitgliedDynamicMonthyear_dynamic_parent_tarifItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif']);
		return \Types\TarifNull::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('tarif').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getData($sqladdon, $params, $id, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params, $id);

								$order = (\FOP\Util::array_value(array(
									'dynamic:time ASC' => 'ORDER BY t.'.qi('dynamic:time').' ASC',
									'dynamic:time DESC' => 'ORDER BY t.'.qi('dynamic:time').' DESC',
									'' => ''), isset($params['sort_mitgliedDynamicMonthyear_dynamic:parent']) ? $params['sort_mitgliedDynamicMonthyear_dynamic:parent'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('dynamic:time').' DESC');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['tarif'] = \FOP\Sanitizers::null_converter($item['tarif']);
											$item['tarifChanged'] = \FOP\Util::BoolSanitizer($item['tarifChanged']);
											$item['dynamic:time'] = intval($item['dynamic:time']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['tarif'] = \FOP\Sanitizers::null_converter($item['tarif']);
										$item['tarifChanged'] = \FOP\Util::BoolSanitizer($item['tarifChanged']);
										$item['dynamic:time'] = intval($item['dynamic:time']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged'])) {
		if ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged'] == '_null') {
			array_push($filters, _('Mitgliedsbeitrag geändert') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarifChanged']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Mitgliedsbeitrag geändert') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time'])) {
		if ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time'] == '_null') {
			array_push($filters, _('validfrom') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_dynamic:time']))->all() AS $val) {
				$value = ($val) ? date(_('monthyearformat_php'), mktime(1, 1, 1, intval($val) % 12 + 1, 1, floor(intval($val)/12))) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('validfrom') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'])) {
		if ($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif'] == '_null') {
			array_push($filters, _('Mitgliedsbeitrag') . ': ' . _('beitragsfrei'));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_mitgliedDynamicMonthyear_dynamic:parent_tarif']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('tarif').'.'.qi('name').' AS description FROM '.qi('tarif').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('beitragsfrei')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Mitgliedsbeitrag') . ': ' . implode(', ', $values));
		}
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_mitgliedDynamicMonthyear_dynamic:parent_\')) delete query[q];} reloadmitgliedDynamicMonthyear_dynamic_parent(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'mitgliedDynamicMonthyear') {
	\FOP\Session::setPayload('dv-mitgliedDynamicMonthyear', [
		'id' => 'mitgliedDynamicMonthyear_dynamic:parent',
		'tbl' => 'mitgliedDynamicMonthyear',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\MitgliedDynamicMonthyear_dynamic_parent::stepURL('mitgliedDynamicMonthyear', 'XXX', -1),
		'next' => \DataViewRouter\MitgliedDynamicMonthyear_dynamic_parent::stepURL('mitgliedDynamicMonthyear', 'XXX',  1),
		'from' => $fop_from,
		'param_id' => $id
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\MitgliedDynamicMonthyear::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query, $dv['param_id']);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



